
package io.zipcoder.casino;

import io.zipcoder.casino.allCasino.ioMessages.PreMadeMessages;
import org.junit.Assert;
import org.junit.Test;

public class PreMadeMessagesTest {
PreMadeMessages messages = new PreMadeMessages();

    @Test
    public void welcomeMessage() {
       String actual = messages.welcomeMessage;
       String expected = "Welcome To The Hello Kitty™ Adventure Island Casino!!";
       Assert.assertEquals(expected, actual);
    }

    @Test
    public void displayTheCat() {
        String actual = messages.displayTheCat;
        String expected =

                        " _   _         _  _          _   __ _\n" +
                        "| | | |  ___  | || |  ___   | | / /(_)  _     _\n" +
                        "| |_| | / _ \\ | || | / _ \\  | |/ /  _ _| |_ _| |_  _  _\n" +
                        "|  _  |/ /_\\ \\| || |/ / \\ \\ |   /  | |_   _|_   _|| |/ /\n" +
                        "| | | |\\ ,___/| || |\\ \\_/ / | |\\ \\ | | | |_  | |_ | / /\n" +
                        "|_| |_| \\___/ |_||_| \\___/  |_| \\_\\|_| \\___| \\___||  /\n" +
                        "                     _           _                / /\n" +
                        "                    / \\_______ /|_\\™              \\/\n" +
                        "                   /          /_/ \\__\n" +
                        "                  /             \\_/ /\n" +
                        "                _|_              |/|_\n" +
                        "                _|_  O    _    O  _|_\n" +
                        "                _|_      (_)      _|_\n" +
                        "                 \\                 /\n" +
                        "                  _\\_____________/_\n" +
                        "                 /  \\/  (___)  \\/  \\\n" +
                        "                 \\__(  o     o  )__/" ;

        Assert.assertEquals(expected, actual);

    }

    @Test
    public void rollTheDice() {
        String actual = messages.rollTheDice;
        String expected =
                "                           (( _______\n" +
                "                 _______     /\\O    O\\\n" +
                "                /O     /\\   /  \\      \\\n" +
                "               /   O  /O \\ / O  \\O____O\\ ))\n" +
                "            ((/_____O/    \\\\    /O     /\n" +
                "              \\O    O\\    / \\  /   O  /\n" +
                "               \\O    O\\ O/   \\/_____O/\n" +
                "                \\O____O\\/ ))          ))\n" +
                "              ((" ;
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void makeItRain() {
        String actual = messages.makeItRain;
        String expected =

                        "                   $$$$                                                            \n" +
                        "           $$$$$$$$$$$$$$$$$                                                       \n" +
                        "       $$$$$$$$$$$$$$$$$$$$$$                                                      \n" +
                        "    $$$$$$         $$$$    $$$$$$$$                                                \n" +
                        "   $$$$$$          $$$$        $$$$$$$                                             \n" +
                        "  $$$$$$           $$$$          $$$$$$                                            \n" +
                        "  $$$$$$           $$$$                                                            \n" +
                        "  $$$$$$           $$$$                             _           _                  \n" +
                        "   $$$$$$          $$$$                            / \\_______ /|_\\™              \n" +
                        "     $$$$$$$$      $$$$                           /          /_/ \\__\\            \n" +
                        "        $$$$$$$$$$$$$$$                          /             \\_/ /\\            \n" +
                        "          $$$$$$$$$$$$$$$$$$                   _|_              |/|_\\             \n" +
                        "             $$$$$$$$$$$$$$$$                  _|_  O    _    O  _|_               \n" +
                        "                   $$$$ $$$$$$$$$$             _|_      (_)      _|_               \n" +
                        "                   $$$$       $$$$$$$           \\                 /               \n" +
                        "                   $$$$          $$$$$$          _\\_____________/_                \n" +
                        "                   $$$$           $$$$$$        /  \\/  (___)  \\/  \\             \n" +
                        "$$$$$$$            $$$$          $$$$$$$        \\__(  o     o  )__/               \n" +
                        " $$$$$$            $$$$          $$$$$$                                            \n" +
                        "  $$$$$$$          $$$$        $$$$$$$                                             \n" +
                        "   $$$$$$$$        $$$$      $$$$$$$                                               \n" +
                        "      $$$$$$$$$$$$$$$$$$$$$$$$$$$$                                                 \n" +
                        "          $$$$$$$$$$$$$$$$$$$$$                                                    \n" +
                        "                   $$$$                                                            \n" ;

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void atmTest() {
        String actual = messages.atm;
        String expected =
                "       _             \n" +
                        "      | |            \n" +
                        "  __ _| |_ _ __ ___  \n" +
                        " / _` | __| '_ ` _ \\ \n" +
                        "| (_| | |_| | | | | |\n" +
                        " \\__,_|\\__|_| |_| |_|";

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void mainMenu() {
        String actual = messages.mainMenu;
        String expected =
                "Welcome To The Main Menu:\n" +
                "See Credits: Shows You How Many Hello Kitty™ Fun Bucks You Currently Have.\n" +
                "Add Credits: Add More Hello Kitty™ Fun Bucks So You Can Continue The Fun!\n" +
                "Play Games: Get A List To Choose From Of All Our Amazing Games! \n" +
                "Exit: Leave The Casino And Make Hello Kitty™ Cry  Ó╭╮Ò...\n" ;
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void warMenu() {
        String actual = messages.warMenu;
        String expected =
                "Welcome To The War Menu:\n" +
                "Exit: Leave The War Room And Head Back To The Casino!\n" ;
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void blackJackMenu() {
        String actual = messages.blackJackMenu;
        String expected =
                "Welcome To The Black Jack Menu:\n" +
                "Bet: Place A Wager On The Next Game.\n" +
                "Hit: Add Another Card To Your Hand.\n" +
                "Stay: Keep Your Current Hand Until The End Of The Game. \n" +
                "Exit: Leave The Black Jack Table And Head Back To The Casino!\n" ;
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void threesMenu() {
        String actual = messages.threesMenu;
        String expected =
                "Welcome To The War Menu:\n" +
                "Bet: Place a Wager On The Next Game.\n"+
                "Exit: Leave The Three's Room And Head Back To The Casino!\n" ;
        Assert.assertEquals(expected, actual);
    }
}
